Index: jobvista-frontend/src/views/applications/ApplicationDetailsModal.js
===================================================================
--- jobvista-frontend/src/views/applications/ApplicationDetailsModal.js	(revision 08f82ec612b1b125feec3dcd5c8c0f1062f09e18)
+++ jobvista-frontend/src/views/applications/ApplicationDetailsModal.js	(revision 4d97b633e131eca76d6c290321725684fc1d5970)
@@ -17,4 +17,5 @@
 import Roles from "../../enumerations/Roles";
 import {ApplicationActions} from "../../redux/actions/applicationActions";
+import {notifyJobAdApply, notifyJobAdUpdate} from "../../utils/toastUtils";
 
 
@@ -25,9 +26,12 @@
     const auth = useSelector(state => state.auth.currentUser)
     const [resumeUrl, setResumeUrl] = useState("");
+    const [additionalFileUrls, setAdditionalFileUrls] = useState([]);
 
-    //const [resumeFile, setResumeFile] = useState(null);
+    const [additionalFiles, setAdditionalFiles] = useState(null);
     const toggleModal = () => {
         setModal(!modal);
     };
+
+    const {register, handleSubmit, control, formState: {errors}} = useForm();
 
     useEffect(() => {
@@ -36,8 +40,36 @@
                 if (success) {
                     setResumeUrl(response);
+
+                    if (application.additionalFileNames.length > 0) {
+                        ApplicationActions.downloadAdditionalFiles(application.id, (success2, response) => {
+                            if (success2) {
+                                setAdditionalFileUrls(response);
+                            }
+                        })
+                    }
                 }
             })
         }
     }, [])
+
+    const updateApplication = async () => {
+        try {
+            const formData = new FormData();
+            if (additionalFiles && additionalFiles.length > 0) {
+                for (let i = 0; i < additionalFiles.length; i++) {
+                    formData.append('additionalFiles', additionalFiles[i]);
+                }
+            }
+
+            dispatch(ApplicationActions.updateApplication(application.id, formData, (success) => {
+                if (success) {
+                    toggleModal()
+                    window.location.reload()
+                }
+            }))
+        } catch (err) {
+            console.error(err)
+        }
+    }
 
     function getFileName(path) {
@@ -50,5 +82,9 @@
 
     return (<div className="modal-wrap">
-        <button onClick={toggleModal} className="application-button">View application</button>
+        {auth.role === Roles.RECRUITER ? <button onClick={toggleModal} className="application-button">View
+            application</button> : (application.status === "UNDER_REVIEW" && application.response.length > 0 && additionalFileUrls.length === 0) ?
+            <button onClick={toggleModal} className="application-button">Update application</button> :
+            <button onClick={toggleModal} className="application-button">View application</button>}
+
         <Modal open={modal} onClose={toggleModal} center>
             <div className="head-modal">
@@ -58,37 +94,82 @@
 
             <div className="modal-content">
-                <form>
+                <form onSubmit={handleSubmit(updateApplication)}>
                     <div className="row">
-                        <div className="col-md-6">
-                            <label className="label">Why are you interested in joining our company?</label>
-                            <textarea disabled type="text" defaultValue={application.questionAnswers[0]} disabled
-                                      placeholder="Write your answer here..." className="application-textarea"/>
-                            <br/><br/>
-                            <label className="label">What makes you a good fit for this position?</label>
-                            <textarea disabled type="text" defaultValue={application.questionAnswers[1]}
-                                      placeholder="Write your answer here..." className="application-textarea"/>
-                            <br/><br/>
-                            <label className="label">What do you hope to achieve in your first 6 months in this
-                                role?</label>
-                            <textarea disabled type="text" defaultValue={application.questionAnswers[2]}
-                                      placeholder="Write your answer here..." className="application-textarea"/>
+                        <div className="col-md-6 d-flex flex-column gap-4">
+                            <div>
+                                <label className="label">Why are you interested in joining our company?</label>
+                                <textarea disabled type="text" defaultValue={application.questionAnswers[0]} disabled
+                                          placeholder="Write your answer here..." className="application-textarea"/>
+                            </div>
+
+                            <div>
+                                <label className="label">What makes you a good fit for this position?</label>
+                                <textarea disabled type="text" defaultValue={application.questionAnswers[1]}
+                                          placeholder="Write your answer here..." className="application-textarea"/>
+                            </div>
+
+                            <div>
+                                <label className="label">What do you hope to achieve in your first 6 months in this
+                                    role?</label>
+                                <textarea disabled type="text" defaultValue={application.questionAnswers[2]}
+                                          placeholder="Write your answer here..." className="application-textarea"/>
+                            </div>
+
 
                         </div>
-                        <div className="col-md-6">
-                            <label htmlFor="start">Curriculum vitae (CV)</label>
-                            <br/>
-                            <a className="resume-link" href={resumeUrl} target="_blank"
-                               rel="noopener noreferrer">{getFileName(application.fileName)}</a>
-                            <br/>
+                        <div className="col-md-6 d-flex flex-column gap-4">
+                            <div>
+                                <label className="label" htmlFor="start">Curriculum vitae (CV)</label>
 
-                            <br/>
-                            <label className="label">Message to the recruiter</label>
-                            <textarea disabled type="text" defaultValue={application.message} placeholder="Optional..."
-                                      className="application-textarea"/>
+                                <a className="resume-link" href={resumeUrl} target="_blank"
+                                   rel="noopener noreferrer">{getFileName(application.fileName)}</a>
+                            </div>
+
+                            <div>
+                                <label className="label">Message to the recruiter</label>
+                                <textarea disabled type="text" defaultValue={application.message}
+                                          placeholder="Optional..."
+                                          className="application-textarea"/>
+                            </div>
+
+
+                            {additionalFileUrls.length > 0 ? (<div>
+                                    <label className="label" htmlFor="start">Additional documents</label>
+                                    <ul style={{listStyleType: "none", padding: 0, margin: 0}}>
+                                        {additionalFileUrls.map((url, index) => (
+                                            <li style={{marginBottom: 10}} key={index}>
+                                                <a href={url} className="resume-link" download target="_blank">
+                                                    {getFileName(url)}
+                                                </a>
+                                            </li>))}
+                                    </ul>
+                                </div>) : (<div>
+                                    {(application.status === "UNDER_REVIEW" && application.response.length > 0 && auth.role == Roles.JOBSEEKER) &&
+                                        <div>
+                                            <label className="label" htmlFor="start">Additional documents</label>
+                                            <input
+                                                className="resume-link"
+                                                onChange={(e) => setAdditionalFiles(e.target.files)}
+                                                required type="file"
+                                                id="fileUpload"
+                                                accept=".pdf"
+                                                multiple
+                                            />
+                                        </div>}
+                                </div>
+                            )}
+
 
                         </div>
                     </div>
+                    {(additionalFileUrls.length  === 0 && application.status === "UNDER_REVIEW" && application.response.length > 0 && auth.role == Roles.JOBSEEKER) &&
+                        <div className="modal-buttons">
+                            <div className="cancel-btn" onClick={toggleModal}> Cancel</div>
+                            <button className="submit-btn"> Submit</button>
+                        </div>}
 
                 </form>
+
+
             </div>
         </Modal>
Index: jobvista-frontend/src/views/applications/Applications.css
===================================================================
--- jobvista-frontend/src/views/applications/Applications.css	(revision 08f82ec612b1b125feec3dcd5c8c0f1062f09e18)
+++ jobvista-frontend/src/views/applications/Applications.css	(revision 4d97b633e131eca76d6c290321725684fc1d5970)
@@ -17,8 +17,51 @@
 }
 
-/*.application-title span {*/
-/*    font-weight: bold;*/
-/*    */
-/*}*/
+.response-message {
+    background-color: floralwhite;
+    border-radius: 8px;
+    padding: 15px;
+    box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
+}
+
+
+
+
+.application-card-wrapper {
+    margin: 15px 0;
+    display: flex;
+    flex-direction: column;
+    transition: all 0.4s ease-in-out;
+    gap: 3px;
+}
+
+.application-card.changed {
+    background-color: aliceblue;
+}
+
+.application-card-wrapper .expand-section {
+    max-height: 0;
+    opacity: 0;
+    transition: 0.5s ease;
+    display: flex;
+    flex-direction: column;
+    align-items: flex-end;
+    margin: 0 !important;
+}
+
+.application-card-wrapper.expanded .expand-section {
+    max-height: 200px;
+    opacity: 1;
+    transform: translateY(0);
+    margin-top: 10px;
+  /*  transition: max-height 0.3s ease, opacity 0.3s ease, transform 0.3s ease;*/
+}
+
+.expand-section textarea {
+    width: 100%;
+    padding: 10px;
+    border-radius: 8px;
+    border: 1px solid #ccc;
+}
+
 
 .application-card {
@@ -29,11 +72,7 @@
     transition: all 0.3s ease;
     box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
-    height: auto;
+    /*height: auto;*/
     padding: 20px 20px;
     display: flex;
-    /*justify-content: center;*/
-    /*gap: 20px;*/
-    margin: 15px 0;
-    /*z-index: -1000;*/
 }
 .application-card .app-job-seeker-pic {
@@ -51,5 +90,5 @@
 
 .application-card .app-info {
-    width: 65%;
+    width: 60%;
     display: inline-flex;
     flex-direction: column;
@@ -86,5 +125,5 @@
 
 .application-card .app-status {
-    width: 28%;
+    width: 38%;
     display: inline-flex;
     justify-content: end;
@@ -98,5 +137,5 @@
 }
 
-.status {
+.app-status .status {
     color: white;
     padding: 5px 10px;
@@ -105,4 +144,10 @@
     text-align: center;
 }
+
+
+
+
+
+
 
 
@@ -168,2 +213,43 @@
     transform: rotate(-10deg);
 }
+
+.application-filters {
+    gap: 15px;
+    border-radius: 8px;
+    background-color: white;
+}
+
+/* Default Span Styles */
+.application-filters span {
+    padding: 8px 12px;
+    border-radius: 5px;
+    color: rgba(1,38,90,0.9);
+    cursor: pointer;
+    display: inline-flex;
+    align-items: center;
+}
+
+/* Icon Styles */
+.application-filters span i {
+    margin-right: 5px;
+}
+
+/* Hover Effect */
+.application-filters span:hover {
+    background-color: rgba(1,38,90,0.9);
+    color: white;
+}
+
+.application-filters span:hover i {
+    color: inherit; /* Makes the icon inherit the color from the parent span */
+}
+
+/* Selected State */
+.application-filters span.selected {
+    background-color: rgba(1,38,90,0.9);
+    color: white;
+}
+
+.application-filters span.selected i {
+    color: inherit; /* Ensures icon color matches the selected state */
+}
Index: jobvista-frontend/src/views/applications/ApplicationsByJobAd.js
===================================================================
--- jobvista-frontend/src/views/applications/ApplicationsByJobAd.js	(revision 08f82ec612b1b125feec3dcd5c8c0f1062f09e18)
+++ jobvista-frontend/src/views/applications/ApplicationsByJobAd.js	(revision 4d97b633e131eca76d6c290321725684fc1d5970)
@@ -25,6 +25,8 @@
     const [jobAdTitle, setJobAdTitle] = useState("");
 
+    const [changedApplications, setChangedApplications] = useState({});
+
     useEffect(() => {
-        if(!dispatched && (applicationsByJobAdState.length === 0 || applicationsByJobAdState.length === 1)) {
+        if(!dispatched) {
             dispatch(ApplicationActions.fetchApplicationsByJobAdId(advertisement_id, (success, reponse) => {
                 if (success && reponse.data.length > 0) {
@@ -60,4 +62,5 @@
     }, [dispatched])
 
+
     const fetchProfilePic = (jobSeekerId) => {
         dispatch(JobSeekerActions.downloadProfilePic(jobSeekerId, (success, response) => {
@@ -67,5 +70,4 @@
         }))
     }
-
 
     const options = [
@@ -76,16 +78,100 @@
     ];
 
+    const [selectedFilter, setSelectedFilter] = useState('All');
+
+    const filters = [
+        { value: 'ALL', label: 'All', icon: 'fa-folder-open' },
+        { value: 'PROPOSED', label: 'Proposed', icon: 'fa-paper-plane' },
+        { value: 'UNDER_REVIEW', label: 'Under Review', icon: 'fa-file-pen' },
+        { value: 'ACCEPTED', label: 'Accepted', icon: 'fa-user-check' },
+        { value: 'DENIED', label: 'Denied', icon: 'fa-user-slash' },
+    ];
+
+    const filterApplicationsByJobAdvertisement = (filter) => {
+        dispatch(ApplicationActions.filterApplicationsByJobAdId(advertisement_id, filter, (success, response) => {
+            if(success) {
+                //notify
+            }
+        }))
+    }
+
     let handleDefaultStatus = (status) => {
         return options.find(option => option.value === status);
     }
 
-    let handleChangeStatus = (selectedOption, id) => {
-        dispatch(ApplicationActions.updateApplicationStatus(id, selectedOption.value, (success, response) => {
+    let handleStatusChange = (selectedOption, id) => {
+
+        const currentApplication = applicationsByJobAd.find(app => app.id === id);
+
+        setChangedApplications(prevState => ({
+            ...prevState,
+            [id]: {
+                ...prevState[id],
+                response: (selectedOption.value === "ACCEPTED" || selectedOption.value === "DENIED") ? (prevState[id]?.response || currentApplication.response || "") : "",
+                status: selectedOption.value
+            }
+        }))
+
+       setApplicationsByJobAd(prevState => (
+           prevState.map(application =>
+           application.id === id ? {...application, status: selectedOption.value} : application)
+       ))
+
+        const responseTextarea = document.getElementById(`response-${id}`);
+        if (responseTextarea) {
+            responseTextarea.value = "";
+        }
+
+       /* dispatch(ApplicationActions.updateApplicationStatus(id, selectedOption.value, (success, response) => {
             if(success) {
-                // console.log("Status updated.")
                 notifyAppStatusUpdate()
             }
-        }))
-    }
+        }))*/
+    }
+
+    let handleResponseChange = (e, id) => {
+
+        const currentApplication = applicationsByJobAd.find(app => app.id === id);
+
+        setChangedApplications(prevState => ({
+                ...prevState,
+                [id]: {
+                    ...prevState[id],
+                    response: e.target.value,
+                    status: prevState[id]?.status || currentApplication.status,
+                }
+            }
+        ))
+    }
+
+    const handleSaveChanges = () => {
+        console.log(changedApplications)
+       const changes = Object.entries(changedApplications).map(
+           ([applicationId, change]) => ({
+               id: applicationId,
+               status: change.status,
+               response: change.response,
+           })
+       );
+        console.log(changes)
+
+       if(changes.length === 0) {
+           return;
+       }
+
+       dispatch(ApplicationActions.updateApplications(changes, (success, response) => {
+           if(success) {
+               setChangedApplications({});
+               notifyAppStatusUpdate()
+               //notify change success
+           }
+       }))
+
+
+    }
+
+    const isChangedApplication = (id) => {
+        return changedApplications && Object.keys(changedApplications).includes(id.toString());
+    };
 
 
@@ -98,40 +184,85 @@
         </div>
 
+        <div className="row">
+            <div className="col-md-6 application-filters-wrap">
+                <div className="application-filters d-inline-flex flex-row justify-content-start">
+                    {
+                        filters.map(filter => (
+                            <span
+                                key={filter.label}
+                                className={selectedFilter === filter.label ? "selected" : ""}
+                                onClick={() => {
+                                    setSelectedFilter(filter.label)
+                                    filterApplicationsByJobAdvertisement(filter.value)
+                                    setChangedApplications({});
+                                }}
+                            ><i className={`fa-solid ${filter.icon}`}></i> {filter.label}</span>
+                        ))
+                    }
+                </div>
+
+            </div>
+            <div className="col-md-6 d-inline-flex flex-row justify-content-end">
+                <button onClick={handleSaveChanges}
+                        className={`blue-submit-button ${Object.keys(changedApplications).length === 0 ? 'disabled' : ''}`}
+                        disabled={Object.keys(changedApplications).length === 0}
+                >Submit Changes</button>
+            </div>
+        </div>
+
+
+
         {applicationsByJobAd && applicationsByJobAd.map((application, index) => (
-            <div className="application-card">
-                <div className="app-job-seeker-pic">
-                    <img
-                        // loading gif
-                        src={profilePicsState[application.jobSeekerId]}
-                        alt=""
-                        width={75} height={75}
-                    />
-                </div>
-                <div className="app-info">
-                    <span>Submitted on <b>{new Date(application.submittedOn).toLocaleString('default', {
-                        day: 'numeric',
-                        month: 'long',
-                        year: 'numeric'
-                    })}</b></span>
-                    <div className="contact-info">
-                        <div className="contact-item">
-                            <i className="fa-solid fa-user"></i> <span>{application.jobSeekerName}</span>
-                        </div> <div className="contact-item">
-                            <i className="fa-solid fa-envelope"></i> <span>{application.jobSeekerEmail}</span>
-                        </div> <div className="contact-item">
-                            <i className="fa-solid fa-phone"></i> <span>{application.jobSeekerPhoneNumber}</span>
+            <div
+                key={application.id}
+                className={`application-card-wrapper ${(application.status !== "PROPOSED" ) ? 'expanded' : ''}`}
+            >
+
+                <div className={`application-card ${changedApplications[application.id] ? 'changed' : ''}`}>
+                    <div className="app-job-seeker-pic">
+                        <img
+                            src={profilePicsState[application.jobSeekerId]}
+                            alt=""
+                            width={75} height={75}
+                        />
+                    </div>
+                    <div className="app-info">
+                <span>Submitted on <b>{new Date(application.submittedOn).toLocaleString('default', {
+                    day: 'numeric',
+                    month: 'long',
+                    year: 'numeric'
+                })}</b></span>
+                        <div className="contact-info">
+                            <div className="contact-item">
+                                <i className="fa-solid fa-user"></i> <span>{application.jobSeekerName}</span>
+                            </div>
+                            <div className="contact-item">
+                                <i className="fa-solid fa-envelope"></i> <span>{application.jobSeekerEmail}</span>
+                            </div>
+                            <div className="contact-item">
+                                <i className="fa-solid fa-phone"></i> <span>{application.jobSeekerPhoneNumber}</span>
+                            </div>
+                        </div>
+                    </div>
+
+                    <div className="app-status">
+                        <ApplicationDetailsModal application={application} />
+                        <div className="select">
+                            <Select options={options} onChange={(selectedOption) => handleStatusChange(selectedOption, application.id)} defaultValue={handleDefaultStatus(application.status)} />
                         </div>
                     </div>
                 </div>
 
-                <div className="app-status">
-                    <ApplicationDetailsModal application={application}/>
-                    <div className="select">
-                        <Select options={options}  onChange={(selectedOption) => handleChangeStatus(selectedOption, application.id)} defaultValue={handleDefaultStatus(application.status)}/>
-                    </div>
-
+                <div className="expand-section">
+                <textarea
+                    id={`response-${application.id}`}
+                    placeholder={application.status === "UNDER_REVIEW" ? "Request additional documents..." :"Write your response..."}
+                    defaultValue={application.response}
+                    onChange={(e) => handleResponseChange(e, application.id)}
+                />
                 </div>
             </div>
-       ))}
+        ))}
+
 
     </div>)
Index: jobvista-frontend/src/views/applications/ApplicationsByJobSeeker.js
===================================================================
--- jobvista-frontend/src/views/applications/ApplicationsByJobSeeker.js	(revision 08f82ec612b1b125feec3dcd5c8c0f1062f09e18)
+++ jobvista-frontend/src/views/applications/ApplicationsByJobSeeker.js	(revision 4d97b633e131eca76d6c290321725684fc1d5970)
@@ -22,9 +22,8 @@
 
 
-
     useEffect(() => {
-        if(!dispatched && (applicationsByJobSeekerState.length === 0 || applicationsByJobSeekerState.length === 1) ) {
+        if (!dispatched && (applicationsByJobSeekerState.length === 0 || applicationsByJobSeekerState.length === 1)) {
             dispatch(ApplicationActions.fetchApplicationsByJobSeeker(auth.id, (success, response) => {
-                if(success && response.data.length > 0) {
+                if (success && response.data.length > 0) {
                     setApplicationsByJobSeeker(sortElementsBy(response.data, "submittedOn"));
                 }
@@ -41,7 +40,7 @@
     useEffect(() => {
 
-        if(dispatched && !logoDispatched) {
+        if (dispatched && !logoDispatched) {
             applicationsByJobSeeker.forEach(jobAd => {
-                if(jobAd.recruiterId && !logos[jobAd.recruiterId]) {
+                if (jobAd.recruiterId && !logos[jobAd.recruiterId]) {
                     fetchLogo(jobAd.recruiterId);
                 }
@@ -49,5 +48,5 @@
             setLogoDispatched(true)
             console.log("Fetch all logos GET")
-        } else if (logoDispatched){
+        } else if (logoDispatched) {
             setLogos(logosState)
             console.log("Fetch all logos STATE")
@@ -58,8 +57,7 @@
 
 
-
     const fetchLogo = (recruiterId) => {
         dispatch(RecruiterActions.downloadLogo(recruiterId, (success, response) => {
-            if(success) {
+            if (success) {
                 setLogos(prevLogos => ({...prevLogos, [recruiterId]: response}))
             }
@@ -67,10 +65,35 @@
     };
 
-    const options = [
-        {value: 'PROPOSED', label: <span className="status" style={{backgroundColor: '#4A90E2'}}><i className="fa-solid fa-paper-plane"></i> Proposed</span>},
-        {value: 'UNDER_REVIEW', label: <span className="status" style={{backgroundColor: '#F5A623'}}><i className="fa-solid fa-file-pen"></i> Under Review</span>},
-        {value: 'ACCEPTED', label: <span className="status" style={{backgroundColor: '#7ED321'}}><i className="fa-solid fa-user-check"></i> Accepted</span>},
-        {value: 'DENIED', label: <span className="status" style={{backgroundColor: '#D0021B'}}><i className="fa-solid fa-user-slash"></i> Denied</span>}
+    const options = [{
+        value: 'PROPOSED', label: <span className="status" style={{backgroundColor: '#4A90E2'}}><i
+            className="fa-solid fa-paper-plane"></i> Proposed</span>
+    }, {
+        value: 'UNDER_REVIEW', label: <span className="status" style={{backgroundColor: '#F5A623'}}><i
+            className="fa-solid fa-file-pen"></i> Under Review</span>
+    }, {
+        value: 'ACCEPTED', label: <span className="status" style={{backgroundColor: '#7ED321'}}><i
+            className="fa-solid fa-user-check"></i> Accepted</span>
+    }, {
+        value: 'DENIED', label: <span className="status" style={{backgroundColor: '#D0021B'}}><i
+            className="fa-solid fa-user-slash"></i> Denied</span>
+    }];
+
+    const [selectedFilter, setSelectedFilter] = useState('All');
+
+    const filters = [
+        { value: 'ALL', label: 'All', icon: 'fa-folder-open' },
+        { value: 'PROPOSED', label: 'Proposed', icon: 'fa-paper-plane' },
+        { value: 'UNDER_REVIEW', label: 'Under Review', icon: 'fa-file-pen' },
+        { value: 'ACCEPTED', label: 'Accepted', icon: 'fa-user-check' },
+        { value: 'DENIED', label: 'Denied', icon: 'fa-user-slash' },
     ];
+
+    const filterApplicationsByJobSeeker= (filter) => {
+        dispatch(ApplicationActions.filterApplicationsByJobSeeker(auth.id, filter, (success, response) => {
+            if(success) {
+                //notify
+            }
+        }))
+    }
 
     let handleDefaultValue = (status) => {
@@ -79,55 +102,77 @@
 
 
-
-    return (
-        <div className="custom-container">
+    return (<div className="custom-container">
 
             <div className="application-title">
                 <h3>Application history</h3>
             </div>
+
+        <div className="application-filters d-inline-flex flex-row justify-content-start">
+            {
+                filters.map(filter => (
+                    <span
+                        key={filter.label}
+                        className={selectedFilter === filter.label ? "selected" : ""}
+                        onClick={() => {
+                            setSelectedFilter(filter.label)
+                            filterApplicationsByJobSeeker(filter.value)
+                        }}
+                    ><i className={`fa-solid ${filter.icon}`}></i> {filter.label}</span>
+                ))
+            }
+        </div>
+
             {applicationsByJobSeeker && applicationsByJobSeeker.map((application, index) => (
-                <div key={index} className="application-card">
-                    <div className="app-company-logo">
-                        <img
-                            // loading gif
-                            src={logosState[application.recruiterId]}
-                            alt=""
-                            width={75} height={75}
-                        />
-                    </div>
+                <div className="application-card-wrapper">
+                    <div key={index} className="application-card">
+                        <div className="app-company-logo">
+                            <img
+                                // loading gif
+                                src={logosState[application.recruiterId]}
+                                alt=""
+                                width={75} height={75}
+                            />
+                        </div>
 
-                    <div className="app-info">
-                        <Link to={`/job-advertisements/${application.jobAdId}`} className="jobAd-title">{application.jobAdTitle}</Link>
-                        {/*<h5 className="jobAd-title"></h5>*/}
-                        <div className="contact-info">
-                            <div className="contact-item">
-                                <i className="fa-solid fa-building"></i> <span>{application.recruiterName}</span>
+                        <div className="app-info">
+                            <Link to={`/job-advertisements/${application.jobAdId}`}
+                                  className="jobAd-title">{application.jobAdTitle}</Link>
+                            {/*<h5 className="jobAd-title"></h5>*/}
+                            <div className="contact-info">
+                                <div className="contact-item">
+                                    <i className="fa-solid fa-building"></i> <span>{application.recruiterName}</span>
+                                </div>
+                                <div className="contact-item">
+                                    <i className="fa-solid fa-envelope"></i> <span>{application.recruiterEmail}</span>
+                                </div>
+                                <div className="contact-item">
+                                    <i className="fa-solid fa-phone"></i>
+                                    <span>{application.recruiterPhoneNumber}</span>
+                                </div>
+                                <span> • Submitted on <b>{new Date(application.submittedOn).toLocaleString('default', {
+                                    day: 'numeric', month: 'long', year: 'numeric'
+                                })}</b></span>
                             </div>
-                            <div className="contact-item">
-                                <i className="fa-solid fa-envelope"></i> <span>{application.recruiterEmail}</span>
-                            </div>
-                            <div className="contact-item">
-                                <i className="fa-solid fa-phone"></i> <span>{application.recruiterPhoneNumber}</span>
-                            </div>
-                            <span> • Submitted on <b>{new Date(application.submittedOn).toLocaleString('default', {
-                                day: 'numeric',
-                                month: 'long',
-                                year: 'numeric'
-                            })}</b></span>
+                        </div>
+
+                        <div className="app-status">
+                            <ApplicationDetailsModal application={application}/>
+                            <> {handleDefaultValue(application.status).label}</>
+                            {/*<div className="select">*/}
+                            {/*    <Select isDisabled={true} options={options} />*/}
+                            {/*</div>*/}
+
                         </div>
                     </div>
+                    {application.response &&
+                        <div className="response-message">
+                            {application.response}
+                        </div>
+                    }
 
-                    <div className="app-status">
-                        <ApplicationDetailsModal application={application}/>
-                        <> {handleDefaultValue(application.status).label}</>
-                        {/*<div className="select">*/}
-                        {/*    <Select isDisabled={true} options={options} />*/}
-                        {/*</div>*/}
+                </div>
 
-                    </div>
-                </div>
             ))}
 
-        </div>
-    )
+        </div>)
 }
Index: jobvista-frontend/src/views/applications/ApplyToJobAdModal.js
===================================================================
--- jobvista-frontend/src/views/applications/ApplyToJobAdModal.js	(revision 08f82ec612b1b125feec3dcd5c8c0f1062f09e18)
+++ jobvista-frontend/src/views/applications/ApplyToJobAdModal.js	(revision 4d97b633e131eca76d6c290321725684fc1d5970)
@@ -105,5 +105,4 @@
                                    onChange={(e) => setResumeFile(e.target.files[0])} required type="file"
                                    id="fileUpload" accept=".pdf"/>
-
                             <br/>
                             <label className="label">Message to the recruiter</label>